#pragma once
///////////////////////////////////////////////////////////////////////////////
// File: CommandLine.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2006 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "ServerCommon/CommandLine.h"

///////////////////////////////////////////////////////////////////////////////
// COpenSSLServerCommandLine
///////////////////////////////////////////////////////////////////////////////

class COpenSSLServerCommandLine : public CCommandLine
{
   public :

      COpenSSLServerCommandLine(
         DWORD argc,
         const char **argv);

      COpenSSLServerCommandLine(
         const COpenSSLServerCommandLine &rhs) = delete;

      COpenSSLServerCommandLine &operator=(
         const COpenSSLServerCommandLine &rhs) = delete;

      bool RequireClientCerts() const;

      JetByteTools::Core::_tstring CertificatePath() const;

      JetByteTools::Core::_tstring Password() const;

   private :

      void ShowMoreHelp() override;
};

///////////////////////////////////////////////////////////////////////////////
// End of file: CommandLine.h
///////////////////////////////////////////////////////////////////////////////
