#pragma once
///////////////////////////////////////////////////////////////////////////////
// File: DatagramSocketConnectionManagerCallback.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2008 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/SocketTools/IDatagramSocketConnectionManagerCallback.h"

///////////////////////////////////////////////////////////////////////////////
// CDatagramSocketConnectionManagerCallback
///////////////////////////////////////////////////////////////////////////////

class CDatagramSocketConnectionManagerCallback :
   public JetByteTools::Socket::IDatagramSocketConnectionManagerCallback
{
   public :

      // Implement IDatagramSocketConnectionManagerCallback

      void OnSocketCreated(
         SOCKET s) override;

      void OnBindCompleted(
         JetByteTools::Socket::IDatagramSocket &socket) override;

      void OnPreOutgoingConnect(
         JetByteTools::Core::IIndexedOpaqueUserData &userData,
         const JetByteTools::Socket::IAddress &address,
         const void *pUserData) override;

      void OnConnectionEstablished(
         JetByteTools::Socket::IDatagramSocket &socket,
         const JetByteTools::Socket::IAddress &address) override;

      void OnOutgoingConnectionFailed(
         JetByteTools::Socket::IDatagramSocket &socket,
         const JetByteTools::Socket::IAddress &address,
         DWORD lastError) override;

      void OnSocketReleased(
         JetByteTools::Core::IIndexedOpaqueUserData &userData) override;

      void OnReadCompleted(
         JetByteTools::Socket::IDatagramSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer) override;

      void OnReadCompletionError(
         JetByteTools::Socket::IDatagramSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer,
         DWORD lastError) override;

      void OnWriteCompleted(
         JetByteTools::Socket::IDatagramSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer) override;

      void OnWriteCompletionError(
         JetByteTools::Socket::IDatagramSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer,
         DWORD lastError) override;

      void OnRecvFromCompleted(
         JetByteTools::Socket::IDatagramSocket &socket,
         const JetByteTools::Socket::IAddress &address,
         JetByteTools::IO::CSmartBuffer &buffer) override;

      void OnRecvFromCompletionError(
         JetByteTools::Socket::IDatagramSocket &socket,
         const JetByteTools::Socket::IAddress &address,
         JetByteTools::IO::CSmartBuffer &buffer,
         DWORD lastError) override;

      void OnSendToCompleted(
         JetByteTools::Socket::IDatagramSocket &socket,
         const JetByteTools::Socket::IAddress &address,
         JetByteTools::IO::CSmartBuffer &buffer) override;

      void OnSendToCompletionError(
         JetByteTools::Socket::IDatagramSocket &socket,
         const JetByteTools::Socket::IAddress &address,
         JetByteTools::IO::CSmartBuffer &buffer,
         DWORD lastError) override;

      void OnMaximumConnections() override;

      void OnAllConnectionsAborted(
         DWORD numberOfConnectionsAborted) override;

      void OnShutdownInitiated() override;

      void OnShutdownComplete() override;

      // IDatagramSocketCallback

      void OnConnectionReset(
          JetByteTools::Socket::IDatagramSocket &socket,
          DWORD lastError) override;

      void OnConnectionClosure(
         JetByteTools::Socket::IDatagramSocket &socket,
         JetByteTools::Socket::ConnectionClosureReason reason) override;

      void OnConnectionClosed(
         JetByteTools::Socket::IDatagramSocket &socket) override;

      // Implement ISocketCallback

      void OnError(
         const JetByteTools::Core::_tstring &message) override;

      void OnError(
         const JetByteTools::Core::_tstring &message,
         DWORD lastError) override;
};

///////////////////////////////////////////////////////////////////////////////
// End of file: DatagramSocketConnectionManagerCallback.h
///////////////////////////////////////////////////////////////////////////////

