@Echo off

REM Most arguments passed to us via the environment as they contain spaces...

if not defined SERVER goto NotSet
if not defined BASE_ARGS goto NotSet
if not defined NUM_CONNECTIONS set NUM_CONNECTIONS=50
if not defined NUM_MESSAGES set NUM_MESSAGES=1000
if not defined READ_TIMEOUT set READ_TIMEOUT=10000

goto DisplayDebug

:NotSet
Echo One or more of the following variables is not set:
Echo -
Echo SERVER=%SERVER%
Echo BASE_ARGS=%BASE_ARGS%
Echo -
Echo Please ensure they are all set in the environment before calling.
Exit /b 1

:DisplayDebug

if not defined JETBYTE_DEBUG_BUILD_SCRIPTS goto NoDebug

Echo Script debug information - RunTests.bat
Echo - 
Echo Required: SERVER=%SERVER%
Echo Required: BASE_ARGS=%BASE_ARGS%
Echo Optional: NUM_CONNECTIONS=%NUM_CONNECTIONS%
Echo Optional: NUM_MESSAGES=%NUM_MESSAGES%
Echo Optional: READ_TIMEOUT=%READ_TIMEOUT%
Echo Optional: ADDITIONAL_CLIENT_ARGS=%ADDITIONAL_CLIENT_ARGS%
Echo -

:NoDebug

:RunTests

setlocal

set TEST_CLIENT_BASE_ARGS=-server localhost -port 5050 -connections %NUM_CONNECTIONS% -connectionBatchSize 100 -connectionBatchDelay 100 -messages %NUM_MESSAGES% -messageRate 0 -sendAfterRecv -readTimeout %READ_TIMEOUT% %ADDITIONAL_CLIENT_ARGS%

set TEST_NAME=%BASE_TEST_NAME% No zero read (OpenSSL client)
set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\OpenSSLEchoServerTest.exe"
set TEST_CLIENT_ARGS=-certificatePath ..\..\Test\ -password clientpassword %TEST_CLIENT_BASE_ARGS%

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% Sync zero read (OpenSSL client)
set SERVER_ARGS=%BASE_ARGS% -syncZero

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% Async zero read (OpenSSL client)
set SERVER_ARGS=%BASE_ARGS% -asyncZero

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% No zero read (SChannel client)
set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\SChannelEchoServerTest.exe"
set TEST_CLIENT_ARGS=-ignoreValidationErrors %TEST_CLIENT_BASE_ARGS%

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% Sync zero read (SChannel client)
set SERVER_ARGS=%BASE_ARGS% -syncZero

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% Async zero read (SChannel client)
set SERVER_ARGS=%BASE_ARGS% -asyncZero

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

